package com.logicbig.example;

import java.lang.reflect.Method;

public class StackWalkerReflectFrameExample {
    public static void main(String[] args) throws Exception {

        Method method1 = StackWalkerReflectFrameExample.class
                .getMethod("doSomething");
        method1.invoke(null);

        Method method2 = StackWalkerReflectFrameExample.class
                .getMethod("doSomething2");
        method2.invoke(null);
    }

    public static void doSomething() {
        System.out.println(" -- without SHOW_REFLECT_FRAMES --");
        StackWalker stackWalker = StackWalker.getInstance();
        stackWalker.forEach(System.out::println);
    }

    public static void doSomething2() {
        System.out.println(" -- with SHOW_REFLECT_FRAMES --");
        StackWalker stackWalker = StackWalker.getInstance(StackWalker.Option.SHOW_REFLECT_FRAMES);
        stackWalker.forEach(System.out::println);
    }
}